//********************************************************
//
// 3D TANK DEMO BY DARKGuy
//
// *** CHANGE THE PATHS OF THE MODELS AND THE FPG BEFORE
// *** COMPILING IT.
//
// Greetz!. This is a little demo of what can you do
// in 2 hours using Antzrhere's AWESOME dll.
//
// The code isn't very commented, though. Sorry about
// that.
//
// There will be more demos coming soon! (and commented,
// of course! :) ).
//
// Antzrhere's home page:
// http://antzrhere.tripod.com
//
// DARKGuy's home page:
// http://el-programador.webcindario.com
//
//********************************************************

PROGRAM _3D_TANK_DEMO;

IMPORT "DLL\SGL.DLL"; //ANTZRHERE'S AWESOME DLL

GLOBAL
STRING TANK_MDL = "DEMOS\3DTANK\TANK.MD2";
STRING TURRET_MDL = "DEMOS\3DTANK\TURRET.MD2";
STRING BULLET_MDL = "DEMOS\3DTANK\BULLET.MD2";

STRING TEXTURES = "DEMOS\3DTANK\TEXTURES.FPG";

TEXTURE_FPG;

FOG_COLOR=1;

PLAYER;
FINISH;


struct matrix_control
sizex;
sizey;
x;
y;
z;
scalex;
scaley;
scalez;
textured_mode;
culling_type;
end= 10,10,0,0,0,10240,128,10240,1,1;

matrix_height[11*11]=
0,0,0,0,0,0,0,0,0,0,0,
0,5000,10000,10000,5000,0,0,5000,10000,10000,0,
0,5000,30000,10000,5000,0,0,5000,30000,10000,0,
0,5000,20000,10000,5000,0,5000,20000,10000,0,0,
0,5000,10000,10000,5000,0,0,5000,10000,10000,0,
0,0,0,0,0,0,0,0,0,0,0,
0,5000,10000,10000,3000,0,0,2000,10000,12000,0,
0,5000,30000,10000,3000,0,0,2000,30000,12000,0,
0,5000,20000,10000,3000,0,5000,20000,10000,0,0,
0,5000,10000,10000,5000,0,0,5000,10000,10000,0,
0,0,0,0,0,0,0,0,0,0,0;

matrix_texture[10*10]=
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1;

//colour data for solid coloured mode
matrix_colour[10*10]=
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32;

ENGINESOUND;
FIRESOUND;

LOCAL
A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W;

BEGIN

    SET_MODE(360360);

    TEXTURE_FPG=LOAD_FPG(TEXTURES);

    LOAD_TEXTURES(); // A function of mine :)
    LOAD_MODELS(); // Another function of mine :)

    ENGINESOUND=LOAD_PCM("DEMOS\3DTANK\ENGINE.PCM",1);
    FIRESOUND=LOAD_PCM("DEMOS\3DTANK\FIRE.PCM",0);

    SET_MODE(320200);
    SET_FPS(24,0);

    INTRO();

    REPEAT
    FRAME;
    UNTIL(FINISH==TRUE);

    WRITE(0,160,0,1, "SGL v0.1.5.8 by Antzrhere"); // credits!
    WRITE(0,160,10,1,"3D Tank Demo by DARKGuy"); // credits!
    WRITE(0,160,20,1,"The 3D models were taken from the internet"); // credits!
    SGL_LOGO(); // Logo of the SGL Library

    sglInit(); //Initialize 3D Mode ;)

    sglSetMaxViewport(); //Full Screen
    sglSetFog(FOG_COLOR,100,15); // Some fogging...
    sglMakeMatrix(&matrix_control,&matrix_height,&matrix_texture);

    sglSetCameraXYZ(0,550,0);


    PLAYER=TANK();
    CAMERA();

    LOOP

        CLEAR_BUFFERS();

        sglRenderMatrix(0);

    FRAME;
    END

END

PROCESS TANK();

BEGIN

    angle=-90000;
    x=54381;
    y=50553;

    TURRET();

    F=SOUND(ENGINESOUND,256,200); // F = ID SOUND

    LOOP

        d=sglGetMatrixHeight(0,x,y);

        if(key(_left) and b>0)
            A-=500;
        end
        if(key(_right) and b>0)
            A+=500;
        end
        if(key(_up))
            B=B+5;
            G+=5; // G=FREQUENCY
        end
        if(key(_down))
            B=B-7;
            G-=5; // G=FREQUENCY
        end

        H=D/100; // FOR SLOPES
        if(e==d)
            IF(H>0)H+=1;END
            IF(H<0)H-=1;END
        end

        IF(G>55)  G=55;   END
        IF(G<-55) G=-55;  END

        CHANGE_SOUND(F,256,200+G);

        angle=ANGLE+A;
        IF(A>2000) A=2000; END
        IF(A<-2000)A=-2000;END
        IF(A>0)    A-=200; END
        IF(A<0)    A+=200; END

        advance(B+H); // H = SPEED IN SLOPES
        IF(B>50)  B=50;       END
        IF(B<-25) B=-25;      END
        IF(B>0)   G-=1; B-=1; END
        IF(B<0)   G+=1; B+=1; END

        e=d; // FOR CHANGING SPEED WHEN DRIVING IN SLOPES

        sglRenderModel(0,0, x,d,y, 0,angle,0, 1024,1024,1024);

    FRAME;
    END

END

PROCESS TURRET();

BEGIN

    LOOP

        X=FATHER.X;
        Y=FATHER.Y;

        IF(KEY(_Q)) ANGLE-=5000; END
        IF(KEY(_W)) ANGLE+=5000; END

        IF(KEY(_SPACE)) A=TRUE; END

        IF(A==TRUE)
            B+=500;
            IF(B==1000) SOUND(FIRESOUND,256,256); BULLET(); END
            IF(B>4000) A=FALSE; B=0; END
        END

        sglRenderModel(1,B, x,FATHER.D,y, 0,FATHER.angle+ID.ANGLE,0, 1024,1024,1024);

    FRAME;
    END

END

PROCESS BULLET();

BEGIN

    X=FATHER.X;
    Y=FATHER.Y;
    D=father.father.d+240;
    angle=father.father.angle+father.angle;

    LOOP

        d-=2;
        advance(120);
        e=sglGetMatrixHeight(0,x,y);

        if(d<=0)break;end
        if(d<=e)break;end

        sglRenderModel(2,B, x,d,y, 0,ANGLE,0, 320,320,320);

    FRAME;
    END

END

PROCESS CAMERA();

BEGIN

    ANGLE=PLAYER.ANGLE;
    o=-350;
    p=580;

    LOOP

        sglSetCameraAxisRotation(sglYAxis(),-player.angle-90000-player.son.angle);

        b=get_distx(PLAYER.angle+player.son.angle,o);
        c=get_disty(PLAYER.angle+player.son.angle,o);
        sglSetCameraXYZ(PLAYER.x+b,player.d+p,PLAYER.y+c);

    FRAME;
    END

END

PROCESS SGL_LOGO();

BEGIN

    X=320-58/2;
    Y=200-32/2;
    GRAPH=3;
    FLAGS=4;
    FILE=TEXTURE_FPG;

    LOOP

    FRAME;
    END

END

PROCESS INTRO();

BEGIN

    CLEAR_SCREEN();

    WRITE(0,160,32,4,            "3D Tank demo");
    WRITE(0,160,32+10,4,         "Created by: DARKGuy (aka The Programmer)");

    WRITE(0,160,32+32+16,4,      "SGL (Software Graphics Library) created by:");
    WRITE(0,160,32+32+16+10,4,   "Ant (aka Antzrhere)");

    WRITE(0,160,32+32+32+16,4,   "This is a little demo showing what can you do");
    WRITE(0,160,32+32+32+10+16,4,"using Antzrhere's SGL dll.");

    WRITE(0,160,32+32+64+16,4,   "Use the arrow keys to move the tank");
    WRITE(0,160,32+32+64+16+10,4,"Use [Q] and [W] to rotate the turret");
    WRITE(0,160,32+32+64+16+20,4,"Use [SPACEBAR] to ""fire""");
    WRITE(0,160,32+32+64+32+32,4,"Press [SPACEBAR] to continue");

    LOOP

        IF(KEY(_SPACE)) BREAK; END

    FRAME;
    END

    DELETE_TEXT(ALL_TEXT);
    FINISH=TRUE;

END

FUNCTION LOAD_TEXTURES();

BEGIN

    sglSetDefaultRB(); //we call this because we are grabbing textures before we have called sglinit() once.
    put(TEXTURE_FPG,1,128,128);
    sglGrabTexture(0,0,255,255);

    clear_screen();
    put(TEXTURE_FPG,2,128,128);
    sglGrabTexture(0,0,255,255);

END

FUNCTION LOAD_MODELS();

BEGIN

    if( sglLoadModel(TANK_MDL) < 0 )exit("Error: Model not found: ""TANK.MD2""",0);end
    sglBindTextureToModel(0,0);

    if( sglLoadModel(TURRET_MDL) < 0 )exit("Error: Model not found: ""TURRET.MD2""",0);end
    sglBindTextureToModel(1,0);

    if( sglLoadModel(BULLET_MDL) < 0 )exit("Error: Model not found: ""BULLET.MD2""",0);end
    sglBindTextureToModel(2,0);

END

PROCESS CLEAR_BUFFERS();

BEGIN

    //MUST be used BEFORE drawing anything
    sglClearRB(FOG_COLOR,sglEntireArea());
    sglClearzbuffer(sglEntireArea());

END